state = {}

function love.load()
	love.graphics.setFont(love.graphics.newFont())
end

function love.update()
	for joy = 1, love.joystick.getNumJoysticks() do
		local j = state[joy]
		if not j then
			state[joy] = {}
			j = state[joy]
			j.name = love.joystick.getName(joy)
			j.axes = {}
			j.numAxes = love.joystick.getNumAxes(joy)
			for axis = 1, j.numAxes do
				j.axes[axis] = 0
			end
			j.buttons = {}
			j.numButtons = love.joystick.getNumButtons(joy)
			for button = 1, j.numButtons do
				j.buttons[button] = false
			end
		end
		for axis = 1, j.numAxes do
			j.axes[axis] = love.joystick.getAxis(joy, axis)
		end
		for button = 1, j.numButtons do
			j.buttons[button] = love.joystick.isDown(joy, button)
		end
	end
end

function love.draw()
	local y = 0
	local height = love.graphics.getFont():getHeight()
	for _, joy in ipairs(state) do
		y = y + height
		love.graphics.print(joy.name .. ":", 10, y)
		for axis, value in ipairs(joy.axes) do
			y = y + height
			love.graphics.print("A" .. axis .. ": " .. value, 20, y)
		end
		for button, value in ipairs(joy.buttons) do
			y = y + height
			love.graphics.print("B" .. button .. ": " .. tostring(value), 20, y)
		end
	end
end
